import { NodeOptions } from '@highlight-run/node';
export { H } from '@highlight-run/node';
import { ConsoleLogger, OnApplicationShutdown, NestInterceptor, ExecutionContext, CallHandler } from '@nestjs/common';
import { Observable } from 'rxjs';

declare class HighlightLogger extends ConsoleLogger implements OnApplicationShutdown {
    readonly opts: NodeOptions;
    constructor(opts: NodeOptions);
    log(message: string, context?: string, asBreadcrumb?: boolean): void;
    error(message: string, trace?: string, context?: string): void;
    warn(message: string, context?: string, asBreadcrumb?: boolean): void;
    debug(message: string, context?: string, asBreadcrumb?: boolean): void;
    verbose(message: string, context?: string, asBreadcrumb?: boolean): void;
    onApplicationShutdown(signal?: string): Promise<void>;
}
declare class HighlightInterceptor implements NestInterceptor, OnApplicationShutdown {
    readonly opts: NodeOptions;
    constructor(opts: NodeOptions);
    onApplicationShutdown(signal?: string): Promise<void>;
    intercept(context: ExecutionContext, next: CallHandler): Observable<any>;
}
declare class HighlightModule {
    static forRoot(options: NodeOptions): {
        exports: (typeof HighlightLogger | typeof HighlightInterceptor)[];
        module: typeof HighlightModule;
        providers: (typeof HighlightLogger | typeof HighlightInterceptor)[];
    };
    static forRootAsync(options: NodeOptions): Promise<{
        exports: (typeof HighlightLogger | typeof HighlightInterceptor)[];
        module: typeof HighlightModule;
        providers: (typeof HighlightLogger | typeof HighlightInterceptor)[];
    }>;
}

export { HighlightInterceptor, HighlightLogger, HighlightModule };
